import 'dart:convert';
import 'package:shared_preferences/shared_preferences.dart';

// 本地存储
class DemonSp {
  
  DemonSp._internal();
  static final DemonSp _instance = DemonSp._internal();

  factory DemonSp() => _instance;

  static late final SharedPreferences prefs;

  Future<void> init() async {
    prefs = await SharedPreferences.getInstance();
  }

  Future<bool> localSet(String key, dynamic jsonVal) async{
    String jsonString = jsonEncode(jsonVal);
    return await prefs.setString(key, jsonString);
  }

  dynamic localGet(String key) {
    String? jsonString = prefs.getString(key);
    return jsonString == null ? null : jsonDecode(jsonString);
  }


  //bool 类型
  Future<bool> setBool(String key, bool val) async {
    return await prefs.setBool(key, val);
  }

  bool getBool(String key, [bool? defValue]) {
    return prefs.getBool(key) ?? defValue ?? true;
  }


    //字符串 类型
  Future<bool> setString(String key, String val) async {
    return await prefs.setString(key, val);
  }

  String getString(String key, [String? defValue]) {
    return prefs.getString(key) ?? defValue ?? "";
  }

  Future<bool> remove(String key) async {
    return await  prefs.remove(key);
  }
}
